diff --git a/krita/benchmarks/kis_floodfill_benchmark.cpp b/krita/benchmarks/kis_floodfill_benchmark.cpp
index 5f3dc6a..da9854f 100644
--- a/krita/benchmarks/kis_floodfill_benchmark.cpp
+++ b/krita/benchmarks/kis_floodfill_benchmark.cpp
@@ -101,7 +101,7 @@ void KisFloodFillBenchmark::benchmarkFlood()
         fillPainter.fillColor(1, 1, false);
 
         dirty = fillPainter.dirtyRegion();
-        delete fillPainter.endTransaction();
+        fillPainter.deleteTransaction();
     }
     
     // uncomment this to see the output
diff --git a/krita/benchmarks/kis_gradient_benchmark.cpp b/krita/benchmarks/kis_gradient_benchmark.cpp
index 2b1921b..f224050 100644
--- a/krita/benchmarks/kis_gradient_benchmark.cpp
+++ b/krita/benchmarks/kis_gradient_benchmark.cpp
@@ -78,7 +78,7 @@ void KisGradientBenchmark::benchmarkGradient()
         fillPainter.paintGradient(QPointF(0,0), QPointF(3000,3000), KisGradientPainter::GradientShapeBiLinear, KisGradientPainter::GradientRepeatNone, true, false, 0, 0, GMP_IMAGE_WIDTH,GMP_IMAGE_HEIGHT);
 
         dirty = fillPainter.dirtyRegion();
-        delete fillPainter.endTransaction();
+        fillPainter.deleteTransaction();
     }
     
     // uncomment this to see the output
diff --git a/krita/benchmarks/kis_projection_benchmark.cpp b/krita/benchmarks/kis_projection_benchmark.cpp
index c5f833b..161d92e 100644
--- a/krita/benchmarks/kis_projection_benchmark.cpp
+++ b/krita/benchmarks/kis_projection_benchmark.cpp
@@ -50,6 +50,14 @@ void KisProjectionBenchmark::benchmarkProjection()
     }
 }
 
+void KisProjectionBenchmark::benchmarkLoading()
+{
+    QBENCHMARK{
+        KisDoc2 doc;
+        doc.loadNativeFormat(QString(FILES_DATA_DIR) + QDir::separator() + "load_test.kra");
+    }
+}
+
 #include "kis_wait_update_done.h"
 
 void KisProjectionBenchmark::benchmarkOverlapping()
diff --git a/krita/benchmarks/kis_projection_benchmark.h b/krita/benchmarks/kis_projection_benchmark.h
index 39721ed..dd4cf90 100644
--- a/krita/benchmarks/kis_projection_benchmark.h
+++ b/krita/benchmarks/kis_projection_benchmark.h
@@ -27,11 +27,11 @@ class KisProjectionBenchmark : public QObject
     Q_OBJECT
 
 private slots:
-    
     void initTestCase();
     void cleanupTestCase();
-    
+
     void benchmarkProjection();
+    void benchmarkLoading();
     void benchmarkOverlapping();
 };
 
diff --git a/krita/image/CMakeLists.txt b/krita/image/CMakeLists.txt
index 14ea692..63fa807 100644
--- a/krita/image/CMakeLists.txt
+++ b/krita/image/CMakeLists.txt
@@ -73,7 +73,7 @@ set(kritaimage_LIB_SRCS
    commands/kis_deselect_global_selection_command.cpp
    commands/kis_image_change_layers_command.cpp
    commands/kis_image_command.cpp
-   commands/kis_image_convert_type_command.cpp
+   commands/kis_image_set_projection_color_space_command.cpp
    commands/kis_image_layer_add_command.cpp
    commands/kis_image_layer_move_command.cpp
    commands/kis_image_layer_remove_command.cpp
@@ -82,7 +82,6 @@ set(kritaimage_LIB_SRCS
    commands/kis_image_node_to_bottom_command.cpp
    commands/kis_image_node_to_top_command.cpp
    commands/kis_image_lock_command.cpp
-   commands/kis_image_props_command.cpp
    commands/kis_image_resize_command.cpp
    commands/kis_layer_command.cpp
    commands/kis_layer_props_command.cpp
@@ -162,14 +161,14 @@ set(kritaimage_LIB_SRCS
    kis_random_generator.cc
    kis_random_sub_accessor.cpp
    kis_shear_visitor.cpp
-   kis_selected_transaction.cc
+   kis_selected_transaction_data.cpp
    kis_selection.cc
    kis_selection_mask.cpp
-   kis_selection_transaction.cc
+   kis_selection_transaction_data.cpp
    kis_serializable_configuration.cc
    kis_shared.cc
    kis_threaded_applicator.cpp
-   kis_transaction.cc
+   kis_transaction_data.cpp
    kis_transform_worker.cc
    kis_transformation_mask.cpp
    kis_transparency_mask.cc
diff --git a/krita/image/commands/kis_image_change_layers_command.cpp b/krita/image/commands/kis_image_change_layers_command.cpp
index 89e5ef4..d12f811 100644
--- a/krita/image/commands/kis_image_change_layers_command.cpp
+++ b/krita/image/commands/kis_image_change_layers_command.cpp
@@ -18,21 +18,11 @@
  */
 
 #include "kis_image_commands.h"
-#include <QString>
-#include <QBitArray>
+#include "kis_image.h"
+#include "kis_group_layer.h"
 
 #include <klocale.h>
 
-#include "KoColorSpaceRegistry.h"
-#include "KoColor.h"
-#include "KoColorProfile.h"
-#include "KoColorSpace.h"
-
-
-#include "kis_image.h"
-#include "kis_layer.h"
-#include "kis_group_layer.h"
-#include "kis_undo_adapter.h"
 
 KisImageChangeLayersCommand::KisImageChangeLayersCommand(KisImageWSP image, KisNodeSP oldRootLayer, KisNodeSP newRootLayer, const QString& name)
         : KisImageCommand(name, image)
@@ -43,22 +33,18 @@ KisImageChangeLayersCommand::KisImageChangeLayersCommand(KisImageWSP image, KisN
 
 void KisImageChangeLayersCommand::redo()
 {
-    setUndo(false);
     m_image->lock();
     m_image->setRootLayer(static_cast<KisGroupLayer*>(m_newRootLayer.data()));
     m_image->unlock();
     m_image->refreshGraph();
     m_image->notifyLayersChanged();
-    setUndo(true);
 }
 
 void KisImageChangeLayersCommand::undo()
 {
-    setUndo(false);
     m_image->lock();
     m_image->setRootLayer(static_cast<KisGroupLayer*>(m_oldRootLayer.data()));
     m_image->unlock();
     m_image->refreshGraph();
     m_image->notifyLayersChanged();
-    setUndo(true);
 }
diff --git a/krita/image/commands/kis_image_change_layers_command.h b/krita/image/commands/kis_image_change_layers_command.h
index e26bdde..71f0d6f 100644
--- a/krita/image/commands/kis_image_change_layers_command.h
+++ b/krita/image/commands/kis_image_change_layers_command.h
@@ -21,17 +21,9 @@
 #define KIS_IMAGE_CHANGE_LAYERS_COMMAND_H_
 
 #include <krita_export.h>
-
-#include <QUndoCommand>
-#include <QSize>
-#include <QBitArray>
 #include "kis_types.h"
 #include "kis_image_command.h"
 
-class KoCompositeOp;
-class KoColorSpace;
-class KoColorProfile;
-
 class KisImageChangeLayersCommand : public KisImageCommand
 {
 
diff --git a/krita/image/commands/kis_image_command.cpp b/krita/image/commands/kis_image_command.cpp
index 7f715f2..985d488 100644
--- a/krita/image/commands/kis_image_command.cpp
+++ b/krita/image/commands/kis_image_command.cpp
@@ -18,21 +18,11 @@
  */
 
 #include "kis_image_commands.h"
-#include <QString>
-#include <QBitArray>
-
 #include <klocale.h>
 
-#include "KoColorSpaceRegistry.h"
-#include "KoColor.h"
-#include "KoColorProfile.h"
-#include "KoColorSpace.h"
-
-
 #include "kis_image.h"
 #include "kis_layer.h"
-#include "kis_group_layer.h"
-#include "kis_undo_adapter.h"
+
 
 KisImageCommand::KisImageCommand(const QString& name, KisImageWSP image)
         : QUndoCommand(name)
@@ -44,13 +34,6 @@ KisImageCommand::~KisImageCommand()
 {
 }
 
-void KisImageCommand::setUndo(bool undo)
-{
-    if (m_image->undoAdapter()) {
-        m_image->undoAdapter()->setUndo(undo);
-    }
-}
-
 static inline bool isLayer(KisNodeSP node) {
     return qobject_cast<KisLayer*>(node.data());
 }
diff --git a/krita/image/commands/kis_image_command.h b/krita/image/commands/kis_image_command.h
index d69021a..b980b97 100644
--- a/krita/image/commands/kis_image_command.h
+++ b/krita/image/commands/kis_image_command.h
@@ -25,12 +25,8 @@
 #include <QUndoCommand>
 #include <QSize>
 #include <QRect>
-#include <QBitArray>
 #include "kis_types.h"
 
-class KoCompositeOp;
-class KoColorSpace;
-class KoColorProfile;
 
 /// the base command for commands altering a KisImage
 class KisImageCommand : public QUndoCommand
@@ -67,13 +63,6 @@ protected:
     };
 
 protected:
-    /**
-     * Lock/Unlocks the undoAdapter for undo operations.
-     * Set this at start and end of commands, which use recursion.
-     * @param undo State the undoAdapter will be set to.
-     */
-    void setUndo(bool undo);
-
     KisImageWSP m_image;
 };
 
diff --git a/krita/image/commands/kis_image_commands.h b/krita/image/commands/kis_image_commands.h
index 151f834..1e81d1e 100644
--- a/krita/image/commands/kis_image_commands.h
+++ b/krita/image/commands/kis_image_commands.h
@@ -21,12 +21,11 @@
 
 #include "kis_image_change_layers_command.h"
 #include "kis_image_command.h"
-#include "kis_image_convert_type_command.h"
+#include "kis_image_set_projection_color_space_command.h"
 #include "kis_image_layer_add_command.h"
 #include "kis_image_layer_move_command.h"
 #include "kis_image_layer_remove_command.h"
 #include "kis_image_lock_command.h"
-#include "kis_image_props_command.h"
 #include "kis_image_resize_command.h"
 
 #endif
diff --git a/krita/image/commands/kis_image_layer_add_command.cpp b/krita/image/commands/kis_image_layer_add_command.cpp
index 038cc9f..997a46f 100644
--- a/krita/image/commands/kis_image_layer_add_command.cpp
+++ b/krita/image/commands/kis_image_layer_add_command.cpp
@@ -18,20 +18,10 @@
  */
 
 #include "kis_image_commands.h"
-#include <QString>
-#include <QBitArray>
+#include "kis_image.h"
 
 #include <klocale.h>
 
-#include "KoColorSpaceRegistry.h"
-#include "KoColor.h"
-#include "KoColorProfile.h"
-#include "KoColorSpace.h"
-
-#include "kis_image.h"
-#include "kis_layer.h"
-#include "kis_group_layer.h"
-#include "kis_undo_adapter.h"
 
 KisImageLayerAddCommand::KisImageLayerAddCommand(KisImageWSP image, KisNodeSP layer, KisNodeSP parent, KisNodeSP aboveThis)
         : KisImageCommand(i18n("Add Layer"), image), m_index(-1)
diff --git a/krita/image/commands/kis_image_layer_add_command.h b/krita/image/commands/kis_image_layer_add_command.h
index c2b95b1..15d8e4d 100644
--- a/krita/image/commands/kis_image_layer_add_command.h
+++ b/krita/image/commands/kis_image_layer_add_command.h
@@ -22,17 +22,10 @@
 
 #include <krita_export.h>
 
-#include <QUndoCommand>
-#include <QSize>
-#include <QBitArray>
 #include "kis_types.h"
 #include "kis_image_command.h"
 
 
-class KoCompositeOp;
-class KoColorSpace;
-class KoColorProfile;
-
 /// The command for adding a layer
 class KRITAIMAGE_EXPORT KisImageLayerAddCommand : public KisImageCommand
 {
diff --git a/krita/image/commands/kis_image_layer_remove_command.cpp b/krita/image/commands/kis_image_layer_remove_command.cpp
index a274b43..3ce8f45 100644
--- a/krita/image/commands/kis_image_layer_remove_command.cpp
+++ b/krita/image/commands/kis_image_layer_remove_command.cpp
@@ -18,21 +18,10 @@
  */
 
 #include "kis_image_commands.h"
-#include <QString>
-#include <QBitArray>
+#include "kis_image.h"
 
 #include <klocale.h>
 
-#include "KoColorSpaceRegistry.h"
-#include "KoColor.h"
-#include "KoColorProfile.h"
-#include "KoColorSpace.h"
-
-
-#include "kis_image.h"
-#include "kis_layer.h"
-#include "kis_group_layer.h"
-#include "kis_undo_adapter.h"
 
 KisImageLayerRemoveCommand::KisImageLayerRemoveCommand(KisImageWSP image, KisNodeSP layer)
         : KisImageCommand(i18n("Remove Layer"), image)
diff --git a/krita/image/commands/kis_image_layer_remove_command.h b/krita/image/commands/kis_image_layer_remove_command.h
index da78d72..8e2a188 100644
--- a/krita/image/commands/kis_image_layer_remove_command.h
+++ b/krita/image/commands/kis_image_layer_remove_command.h
@@ -22,17 +22,10 @@
 
 #include <krita_export.h>
 
-#include <QUndoCommand>
-#include <QSize>
-#include <QBitArray>
 #include "kis_types.h"
 #include "kis_image_command.h"
 
 
-class KoCompositeOp;
-class KoColorSpace;
-class KoColorProfile;
-
 /// The command for removing a layer
 class KRITAIMAGE_EXPORT KisImageLayerRemoveCommand : public KisImageCommand
 {
diff --git a/krita/image/commands/kis_image_lock_command.cpp b/krita/image/commands/kis_image_lock_command.cpp
index b1105ee..b6e7186 100644
--- a/krita/image/commands/kis_image_lock_command.cpp
+++ b/krita/image/commands/kis_image_lock_command.cpp
@@ -18,21 +18,10 @@
  */
 
 #include "kis_image_commands.h"
-#include <QString>
-#include <QBitArray>
+#include "kis_image.h"
 
 #include <klocale.h>
 
-#include "KoColorSpaceRegistry.h"
-#include "KoColor.h"
-#include "KoColorProfile.h"
-#include "KoColorSpace.h"
-
-
-#include "kis_image.h"
-#include "kis_layer.h"
-#include "kis_group_layer.h"
-#include "kis_undo_adapter.h"
 
 KisImageLockCommand::KisImageLockCommand(KisImageWSP image, bool lockImage)
         : KisImageCommand("lock image", image)  // Not for translation, this is only ever used inside a macro command.
@@ -42,25 +31,21 @@ KisImageLockCommand::KisImageLockCommand(KisImageWSP image, bool lockImage)
 
 void KisImageLockCommand::redo()
 {
-    setUndo(false);
     if (m_lockImage) {
         m_image->lock();
     } else {
         m_image->unlock();
     }
     m_image->refreshGraph();
-    setUndo(true);
 }
 
 void KisImageLockCommand::undo()
 {
-    setUndo(false);
     if (m_lockImage) {
         m_image->unlock();
     } else {
         m_image->lock();
     }
     m_image->refreshGraph();
-    setUndo(true);
 }
 
diff --git a/krita/image/commands/kis_image_lock_command.h b/krita/image/commands/kis_image_lock_command.h
index 84b6471..2b8cdce 100644
--- a/krita/image/commands/kis_image_lock_command.h
+++ b/krita/image/commands/kis_image_lock_command.h
@@ -23,8 +23,6 @@
 #include <krita_export.h>
 
 #include <QUndoCommand>
-#include <QSize>
-#include <QBitArray>
 #include "kis_types.h"
 #include "kis_image_command.h"
 
diff --git a/krita/image/commands/kis_image_resize_command.cpp b/krita/image/commands/kis_image_resize_command.cpp
index 293a4f7..04364a5 100644
--- a/krita/image/commands/kis_image_resize_command.cpp
+++ b/krita/image/commands/kis_image_resize_command.cpp
@@ -18,45 +18,26 @@
  */
 
 #include "kis_image_commands.h"
-#include <QString>
-#include <QBitArray>
+#include "kis_image.h"
 
 #include <klocale.h>
 
-#include "KoColorSpaceRegistry.h"
-#include "KoColor.h"
-#include "KoColorProfile.h"
-#include "KoColorSpace.h"
-
-
-#include "kis_image.h"
-#include "kis_layer.h"
-#include "kis_group_layer.h"
-#include "kis_undo_adapter.h"
 
-KisImageResizeCommand::KisImageResizeCommand(KisImageWSP image, qint32 width, qint32 height, qint32 oldWidth, qint32 oldHeight)
+KisImageResizeCommand::KisImageResizeCommand(KisImageWSP image,
+                                             const QSize& newSize)
         : KisImageCommand(i18n("Resize Image"), image)
 {
-    m_before = QSize(oldWidth, oldHeight);
-    m_after = QSize(width, height);
+    // do we really need a translatable name for the command?
+    m_sizeBefore = image->size();
+    m_sizeAfter = newSize;
 }
 
 void KisImageResizeCommand::redo()
 {
-    setUndo(false);
-    m_image->lock();
-    m_image->resize(m_after.width(), m_after.height());
-    m_image->unlock();
-    m_image->refreshGraph();
-    setUndo(true);
+    m_image->setSize(m_sizeAfter);
 }
 
 void KisImageResizeCommand::undo()
 {
-    setUndo(false);
-    m_image->lock();
-    m_image->resize(m_before.width(), m_before.height());
-    m_image->unlock();
-    m_image->refreshGraph();
-    setUndo(true);
+    m_image->setSize(m_sizeBefore);
 }
diff --git a/krita/image/commands/kis_image_resize_command.h b/krita/image/commands/kis_image_resize_command.h
index b9c4810..c40c6b8 100644
--- a/krita/image/commands/kis_image_resize_command.h
+++ b/krita/image/commands/kis_image_resize_command.h
@@ -35,16 +35,15 @@ class KoColorProfile;
 
 class KisImageResizeCommand : public KisImageCommand
 {
-
 public:
-    KisImageResizeCommand(KisImageWSP image, qint32 width, qint32 height, qint32 oldWidth, qint32 oldHeight);
+    KisImageResizeCommand(KisImageWSP image, const QSize& newRect);
 
-    virtual void redo();
-    virtual void undo();
+    void redo();
+    void undo();
 
 private:
-    QSize m_before;
-    QSize m_after;
+    QSize m_sizeBefore;
+    QSize m_sizeAfter;
 };
 
 #endif
diff --git a/krita/image/commands/kis_image_set_projection_color_space_command.cpp b/krita/image/commands/kis_image_set_projection_color_space_command.cpp
new file mode 100644
index 0000000..8c9cdbb
--- /dev/null
+++ b/krita/image/commands/kis_image_set_projection_color_space_command.cpp
@@ -0,0 +1,43 @@
+/*
+ *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *  Copyright (c) 2007 Sven Langkamp <sven.langkamp@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_image_commands.h"
+
+#include "KoColorSpace.h"
+#include "kis_image.h"
+
+#include <klocale.h>
+
+
+KisImageSetProjectionColorSpaceCommand::KisImageSetProjectionColorSpaceCommand(KisImageWSP image, const KoColorSpace * afterColorSpace)
+    : KisImageCommand(i18n("Convert Image Type"), image)
+{
+    m_beforeColorSpace = image->colorSpace();
+    m_afterColorSpace = afterColorSpace;
+}
+
+void KisImageSetProjectionColorSpaceCommand::redo()
+{
+    m_image->setProjectionColorSpace(m_afterColorSpace);
+}
+
+void KisImageSetProjectionColorSpaceCommand::undo()
+{
+    m_image->setProjectionColorSpace(m_beforeColorSpace);
+}
diff --git a/krita/image/commands/kis_image_set_projection_color_space_command.h b/krita/image/commands/kis_image_set_projection_color_space_command.h
new file mode 100644
index 0000000..617b92d
--- /dev/null
+++ b/krita/image/commands/kis_image_set_projection_color_space_command.h
@@ -0,0 +1,42 @@
+/*
+ *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *  Copyright (c) 2007 Sven Langkamp <sven.langkamp@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_IMAGE_SET_PROJECTION_COLOR_SPACE_COMMAND_H_
+#define KIS_IMAGE_SET_PROJECTION_COLOR_SPACE_COMMAND_H_
+
+#include <krita_export.h>
+#include "kis_image_command.h"
+
+class KoColorSpace;
+
+class KisImageSetProjectionColorSpaceCommand : public KisImageCommand
+{
+public:
+    KisImageSetProjectionColorSpaceCommand(KisImageWSP image, const KoColorSpace * afterColorSpace);
+
+    virtual void redo();
+    virtual void undo();
+
+private:
+    const KoColorSpace * m_beforeColorSpace;
+    const KoColorSpace * m_afterColorSpace;
+};
+
+
+#endif /* KIS_IMAGE_SET_PROJECTION_COLOR_SPACE_COMMAND_H_ */
diff --git a/krita/image/commands/kis_set_global_selection_command.h b/krita/image/commands/kis_set_global_selection_command.h
index ab46915..777c500 100644
--- a/krita/image/commands/kis_set_global_selection_command.h
+++ b/krita/image/commands/kis_set_global_selection_command.h
@@ -33,7 +33,7 @@ public:
      * @param parent the parent command
      * @param selection the selection that will be set a global selection, if 0 a new selection will be created
      */
-    KisSetGlobalSelectionCommand(KisImageWSP image, QUndoCommand * parent, KisSelectionSP selection = 0);
+    KisSetGlobalSelectionCommand(KisImageWSP image, QUndoCommand * parent = 0, KisSelectionSP selection = 0);
     virtual ~KisSetGlobalSelectionCommand();
 
     virtual void redo();
diff --git a/krita/image/kis_colorspace_convert_visitor.cpp b/krita/image/kis_colorspace_convert_visitor.cpp
index f8dd5c8..fc9f403 100644
--- a/krita/image/kis_colorspace_convert_visitor.cpp
+++ b/krita/image/kis_colorspace_convert_visitor.cpp
@@ -17,10 +17,14 @@
  */
 
 #include "kis_colorspace_convert_visitor.h"
-#include "kis_transaction.h"
 #include "kis_image.h"
+#include "kis_paint_device.h"
 #include "kis_undo_adapter.h"
 #include "commands/kis_layer_props_command.h"
+#include "kis_adjustment_layer.h"
+#include "kis_paint_layer.h"
+#include "kis_group_layer.h"
+#include "kis_external_layer_iface.h"
 #include "filter/kis_filter_configuration.h"
 #include "filter/kis_filter_registry.h"
 #include "filter/kis_filter.h"
@@ -102,43 +106,31 @@ bool KisColorSpaceConvertVisitor::convertPaintDevice(KisLayer* layer)
             layer->name(), layer->name(),
             layer->channelFlags(), m_emptyChannelFlags);
 
-    if (m_image && m_image->undoAdapter()) {
-        m_image->undoAdapter()->addCommand(propsCommand);
-    }
+    m_image->undoAdapter()->addCommand(propsCommand);
 
     if (layer->original()) {
         QUndoCommand* cmd = layer->original()->convertTo(m_dstColorSpace, m_renderingIntent);
-        if (m_image->undoAdapter()) {
-            if (cmd) {
-                m_image->undoAdapter()->addCommand(cmd);
-            }
-        }
-        else {
+        if (cmd)
+            m_image->undoAdapter()->addCommand(cmd);
+        else
             delete cmd;
-        }
     }
 
     if (layer->paintDevice()) {
         QUndoCommand* cmd = layer->paintDevice()->convertTo(m_dstColorSpace, m_renderingIntent);
-        if (m_image->undoAdapter()) {
-            if (cmd) {
-                m_image->undoAdapter()->addCommand(cmd);
-            }
-        }
-        else {
+        if (cmd)
+            m_image->undoAdapter()->addCommand(cmd);
+        else
             delete cmd;
-        }    }
+    }
 
     if (layer->projection()) {
         QUndoCommand* cmd = layer->projection()->convertTo(m_dstColorSpace, m_renderingIntent);
-        if (m_image->undoAdapter()) {
-            if (cmd) {
-                m_image->undoAdapter()->addCommand(cmd);
-            }
-        }
-        else {
+        if (cmd)
+            m_image->undoAdapter()->addCommand(cmd);
+        else
             delete cmd;
-        }    }
+    }
 
     layer->setDirty();
 
diff --git a/krita/image/kis_colorspace_convert_visitor.h b/krita/image/kis_colorspace_convert_visitor.h
index 5e248ec..e7d02d7 100644
--- a/krita/image/kis_colorspace_convert_visitor.h
+++ b/krita/image/kis_colorspace_convert_visitor.h
@@ -18,21 +18,15 @@
 #ifndef KIS_COLORSPACE_CONVERT_VISITOR_H_
 #define KIS_COLORSPACE_CONVERT_VISITOR_H_
 
-#include <QBitArray>
 
 #include <KoColorConversionTransformation.h>
 #include <KoColorSpace.h>
-#include <KoCompositeOp.h>
 
 #include <krita_export.h>
 #include "kis_global.h"
 #include "kis_types.h"
 #include "kis_node_visitor.h"
-#include "kis_paint_layer.h"
-#include "kis_paint_device.h"
-#include "kis_adjustment_layer.h"
-#include "kis_group_layer.h"
-#include "kis_external_layer_iface.h"
+
 
 /**
  * This will convert all layers to the destination color space.
diff --git a/krita/image/kis_crop_visitor.h b/krita/image/kis_crop_visitor.h
index a26e4de..3e6139c 100644
--- a/krita/image/kis_crop_visitor.h
+++ b/krita/image/kis_crop_visitor.h
@@ -29,7 +29,6 @@
 #include "kis_paint_layer.h"
 #include "kis_adjustment_layer.h"
 #include "kis_transaction.h"
-#include "kis_selected_transaction.h"
 #include "kis_selection.h"
 #include "kis_external_layer_iface.h"
 #include "kis_undo_adapter.h"
@@ -57,12 +56,10 @@ public:
     }
 
     bool visit(KisExternalLayer *layer) {
-        KisUndoAdapter* undoAdapter = layer->image()->undoAdapter();
-        
-        QUndoCommand* cmd = layer->crop(m_rect);
-        if (cmd && undoAdapter && undoAdapter->undo()) {
-            undoAdapter->addCommand(cmd);
-        }
+        KisUndoAdapter *undoAdapter = layer->image()->undoAdapter();
+        QUndoCommand* command = layer->crop(m_rect);
+        if (command)
+            undoAdapter->addCommand(command);
         return true;
     }
 
@@ -119,28 +116,17 @@ public:
 private:
 
     bool cropPaintDeviceLayer(KisLayer * layer) {
+        KisUndoAdapter *undoAdapter = layer->image()->undoAdapter();
 
-        KisPaintDeviceSP dev = layer->paintDevice();
-        KisUndoAdapter* undoAdapter = layer->image()->undoAdapter();
-
-        KisSelectedTransaction * t = 0;
-        if (undoAdapter && undoAdapter->undo())
-            t = new KisSelectedTransaction(i18n("Crop"), layer);
-
-        layer->setDirty();
-        dev->crop(m_rect);
-
-        if (undoAdapter && undoAdapter->undo()) {
-            undoAdapter->addCommand(t);
-        }
+        KisSelectedTransaction transaction(i18n("Crop"), layer);
+        layer->paintDevice()->crop(m_rect);
+        transaction.commit(undoAdapter);
 
         if (m_movelayers) {
-            if (undoAdapter && undoAdapter->undo()) {
-                QPoint oldPos(layer->x(), layer->y());
-                QPoint newPos(layer->x() - m_rect.x(), layer->y() - m_rect.y());
-                QUndoCommand * cmd = new KisNodeMoveCommand(layer, oldPos, newPos);
-                undoAdapter->addCommand(cmd);
-            }
+            QPoint oldPos(layer->x(), layer->y());
+            QPoint newPos(layer->x() - m_rect.x(), layer->y() - m_rect.y());
+            QUndoCommand *cmd = new KisNodeMoveCommand(layer, oldPos, newPos);
+            undoAdapter->addCommand(cmd);
         }
         return true;
     }
diff --git a/krita/image/kis_gradient_job.cpp b/krita/image/kis_gradient_job.cpp
index ba703c4..84139f4 100644
--- a/krita/image/kis_gradient_job.cpp
+++ b/krita/image/kis_gradient_job.cpp
@@ -58,7 +58,7 @@ void KisGradientJob::run()
     painter.setCompositeOp(m_config->compositeOp);
     painter.setGradient(m_config->gradient);
     painter.setPaintColor(m_config->fgColor);
-    painter.beginTransaction(m_config->transaction);
+    painter.putTransaction(m_config->transaction);
 
     painter.paintGradient(m_config->vectorStart, m_config->vectorEnd,
                           m_config->shape, m_config->repeat,
@@ -66,7 +66,7 @@ void KisGradientJob::run()
                           m_config->reverse,
                           m_rc.x(), m_rc.y(), m_rc.width(), m_rc.height());
 
-    painter.endTransaction();
+    painter.takeTransaction();
 
     m_updater->setProgress(100);
 }
